## net.sf.saxon.xpath
Class XPathFunctionLibrary

    java.lang.Object
      net.sf.saxon.xpath.XPathFunctionLibrary

All Implemented Interfaces:
  java.io.Serializable, FunctionLibrary

    public class XPathFunctionLibrary

extends java.lang.Object
implements FunctionLibrary

The XPathFunctionLibrary is a FunctionLibrary that supports binding of XPath function calls to instances of the JAXP XPathFunction interface returned by an XPathFunctionResolver.

See Also:
  Serialized Form

Constructor Summary
`XPathFunctionLibrary()` Construct a XPathFunctionLibrary

Method Summary
`Expression` `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`javax.xml.xpath.XPathFunctionResolver` `getXPathFunctionResolver()` Get the resolver
`boolean` `isAvailable(StructuredQName functionName, int arity)` Test whether an XPath function with a given name and arity is available.
`void` `setXPathFunctionResolver(javax.xml.xpath.XPathFunctionResolver resolver)` Set the resolver

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathFunctionLibrary

    public XPathFunctionLibrary()

  Construct a XPathFunctionLibrary

Method Detail

### setXPathFunctionResolver

    public void setXPathFunctionResolver(javax.xml.xpath.XPathFunctionResolver resolver)

  Set the resolver

  Parameters:
    `resolver` - The XPathFunctionResolver wrapped by this FunctionLibrary

### getXPathFunctionResolver

    public javax.xml.xpath.XPathFunctionResolver getXPathFunctionResolver()

  Get the resolver

  Returns:
    the XPathFunctionResolver wrapped by this FunctionLibrary

### isAvailable

    public boolean isAvailable(StructuredQName functionName,
                               int arity)

  Test whether an XPath function with a given name and arity is available. This supports the function-available() function in XSLT. It is thus never used, and always returns false

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some
  Returns:
    true if a function of this name and arity is available for calling.

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `env` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Copyright (c) Saxonica Limited. All rights reserved.